#include "COMSomme.h"
#include "GestionnaireDeVerrou.h"

// Pour IUnknown
unsigned long __stdcall COMSomme::AddRef ()
{
   return ++m_CptRef;
}

unsigned long __stdcall COMSomme::Release ()
{
   if (--m_CptRef != 0)
      return m_CptRef;
   delete this;
   return 0L;
}

HRESULT __stdcall COMSomme::QueryInterface (REFIID riid, void **ppv)
{
   if (riid == IID_IUnknown)
   {
      *ppv = static_cast<IUnknown *> (this);
   }
   else if (riid == IID_ISomme)
   {
      *ppv = static_cast<ISomme *> (this);
   }
   else
   {
      *ppv = 0;
      return E_NOINTERFACE;
   }
   AddRef ();
   return S_OK;
}

// Pour ISomme
HRESULT __stdcall COMSomme::Somme (int x, int y, int *Resultat)
{
   *Resultat = x + y;
   return S_OK;
}


// constructeur et destructeur 
COMSomme::COMSomme () : ISomme (), m_CptRef (1)
{
   GestionnaireDeVerrou::GetInstance ()->Incrementer ();
}

COMSomme::~COMSomme ()
{
   GestionnaireDeVerrou::GetInstance ()->Decrementer ();
}

