#include "FabriqueSomme.h"
#include "COMSomme.h"
#include "GestionnaireDeVerrou.h"

// constructeur et destructeur 
FabriqueSomme::FabriqueSomme () : IClassFactory(), m_CptRef (1)
{
}

FabriqueSomme::~FabriqueSomme ()
{
}

// Pour IUnknown
unsigned long __stdcall FabriqueSomme::AddRef ()
{
   return ++m_CptRef;
}

unsigned long __stdcall FabriqueSomme::Release ()
{
   if (--m_CptRef != 0)
      return m_CptRef;
   delete this;
   return 0L;
}

HRESULT FabriqueSomme::QueryInterface (REFIID riid, void **ppv)
{
   if (riid == IID_IUnknown)
   {
      *ppv = static_cast<IUnknown*> (this);
   }
   else if (riid == IID_IClassFactory)
   {
      *ppv = static_cast<IClassFactory*> (this);
   }
   else
   {
      *ppv = 0;
      return E_NOINTERFACE;
   }
   AddRef ();
   return S_OK;
}

// Pour IClassFactory
HRESULT FabriqueSomme::CreateInstance (IUnknown *pUnkOuter,
                                       REFIID riid,
                                       void **ppv)
{
   if (pUnkOuter != 0) // rejet de tout pUnkOuter non nul
   {
      return CLASS_E_NOAGGREGATION;
   }
   // Instanciation du composant
   COMSomme *pCOMSomme = new COMSomme;
   if (pCOMSomme == 0) // mmoire insuffisante?
      return E_OUTOFMEMORY;
   // Interrogation de l'identit du composant
   HRESULT hr = pCOMSomme ->QueryInterface (riid, ppv);
   pCOMSomme->Release ();
   return hr;
}

HRESULT FabriqueSomme::LockServer (BOOL Verrou)
{
   if (Verrou)
      GestionnaireDeVerrou::GetInstance ()->Incrementer ();
   else
      GestionnaireDeVerrou::GetInstance ()->Decrementer ();
   return S_OK;
}
